Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
   
        Dim thisExe As System.Reflection.Assembly = System.Reflection.Assembly.GetExecutingAssembly()
        Dim file As System.IO.Stream = thisExe.GetManifestResourceStream("ICD10Browser.Basis.xml")

        Dim Reader As New Xml.XmlTextReader(file)
        Dim xmlDoc As Xml.XmlDocument = New Xml.XmlDocument
        xmlDoc.Load(Reader)
        Reader.Close()

        Dim xnod As Xml.XmlNode = xmlDoc.DocumentElement

        Me.TreeView1.BeginUpdate()
        Dim Idx As Integer, TN As TreeNode
        For Each Nd As Xml.XmlNode In xnod.ChildNodes
            Idx = CInt(Nd.Attributes("I").Value)
            TN = New TreeNode(Nd.Attributes("T").Value, Idx, Idx)
            Me.TreeView1.Nodes.Add(TN)
            Knoten_Hinzufgen(TN, Nd)
        Next
        Me.TreeView1.EndUpdate()
    End Sub
    Private Sub Knoten_Hinzufgen(ByVal TN As TreeNode, ByVal Nd As Xml.XmlNode)
        Dim Idx As Integer, Nda As TreeNode
        For Each xKn1 As Xml.XmlNode In Nd.ChildNodes
            Idx = CInt(xKn1.Attributes("I").Value)
            Nda = New TreeNode(xKn1.Attributes("T").Value, Idx, Idx)
            TN.Nodes.Add(Nda)
            Knoten_Hinzufgen(Nda, xKn1)
        Next
    End Sub

    Private Sub Suchen()
        Dim Nodes As New List(Of TreeNode)

        Dim txt As String = Me.TextBoxSuchwort.Text.Trim.ToLower
        If txt <> "" Then
            Dim Teile() As String = txt.Split
            For Each Nd As TreeNode In Me.TreeView1.Nodes
                NodeDurchsuchen(Teile, Nd, Nodes)
            Next
        End If

        Me.TreeNodeListBox1.SetItems(Nodes)

    End Sub
    Private Sub NodeDurchsuchen(ByVal Texte() As String, ByVal TN As TreeNode, ByVal Nodes As List(Of TreeNode))
        Dim Gef As Boolean = True
        For Each txt As String In Texte
            If TN.Text.ToLower.IndexOf(txt) = -1 Then
                Gef = False
                Exit For
            End If
        Next
        If Gef Then
            Nodes.Add(TN)
        End If
        For Each Nd As TreeNode In TN.Nodes
            NodeDurchsuchen(Texte, Nd, Nodes)
        Next
    End Sub
    Private Sub ButtonSuchen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSuchen.Click
        Suchen()
    End Sub

    Private Sub TextBoxSuchwort_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxSuchwort.KeyDown
        If e.KeyCode = Keys.Enter Then
            Suchen()
        End If
    End Sub
    Private Sub TreeView1_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        Dim TN As TreeNode = e.Node
        Me.TextBoxEintrag.Text = TN.Text
        Clipboard.SetDataObject(TN.Text, True)
    End Sub

    Private Sub ToolStripMenuItemAlleSchliessen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemAlleSchliessen.Click
        Me.TreeView1.CollapseAll()
    End Sub
    Private Sub TreeView1_BeforeExpand(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeExpand
        If e.Node.ImageIndex = 0 Then
            e.Node.ImageIndex = 6
            e.Node.SelectedImageIndex = 6
        End If
    End Sub

    Private Sub TreeView1_BeforeCollapse(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeCollapse
        If e.Node.ImageIndex = 6 Then
            e.Node.ImageIndex = 0
            e.Node.SelectedImageIndex = 0
        End If
    End Sub


End Class
