Public Class TreeNodeListBoxList
    Inherits List(Of TreeNodeListBoxItem)
    Private m_Height As Integer = 0

    Private m_Box As TreeNodeListBox
    Private m_Width As Integer
    Public Sub New(ByVal Box As TreeNodeListBox, ByVal Width As Integer)
        m_Box = Box
        m_Width = Width
    End Sub

    ReadOnly Property Height() As Integer
        Get
            Return m_Height
        End Get
    End Property
    WriteOnly Property Width() As Integer
        Set(ByVal value As Integer)
            If m_Width <> value Then
                m_Width = value
                Dim g As Graphics = m_Box.CreateGraphics
                Recalculate(g)
            End If
        End Set
    End Property

    Public Sub Recalculate(ByVal g As Graphics)
        Dim OldHeigth As Integer = m_Height

        Dim TmpHeight As Integer = 0
        For Each Itm As TreeNodeListBoxItem In Me
            Itm.Top = TmpHeight
            TmpHeight += Itm.CalculateHeight(g, m_Box.Font, m_Width)
        Next

        m_Height = TmpHeight + 5

    End Sub

  
End Class
